# setwd('/esarchive/scratch/smoreno/gitlab/capacity_factors/')
source('config.R')

args <- commandArgs(trailingOnly = TRUE)
model <- args[1]
members <- args[2]
method <- args[3]
region <- args[4]
agregation <- 'seasons'
region <- 'Iberia'
if (region == 'Europe'){
  grid <- config$grid_25
} else {
  grid <- config$grid_down
}
fperiods <- '1'
# config$regions = list('Iberia' = list('lon_min' = 0, 'lon_max' = 6, 'lat_min' = 31, 'lat_max' = 35))
reference <- 'ERA5land'
# model <- 'BCC-CSM2-MR'
# members <- 'r1i1p1f1'
# config$sdates <- 1961:1964
# config$years <- 1960:1963

if (identical(fperiods,'all')){
  fperiods <- config$fperiods
} else {
  aux <- unlist(strsplit(x = fperiods, split = ','))
  fperiods <- list()
  for (i in 1:length(aux)){
    auxi <- unlist(strsplit(x = aux[i], split = '-'))
    fperiods[[i]] <- seq(from = auxi[1], to = auxi[length(auxi)], by = 1)
  }
}

  for (fyears in fperiods){
    time_starting_exec <- proc.time()
    
    if (length(fyears) == 1){fyears_string <- paste0('fyear',fyears[1])} else {fyears_string <- paste0('fyears',fyears[1],'-',fyears[length(fyears)])}
    sdates <- config$sdates[1] : (config$years[length(config$years)] - as.integer(fyears[length(fyears)]))
    years <- (sdates[1] + as.integer(fyears[1])) : config$years[length(config$years)]
    # indices_for_clim <- seq(from = (config$reference_period[1]-years[1]+1), length.out = length(config$reference_period)-length(fyears)+1)

    print(paste0('Starting ',model,' - ',fyears_string, ' - ', members))
    
    ################################################################################################
    #################################### Loading the data ##########################################
    ################################################################################################
    
    print('Loading the data...')
    time_dim <- 'sdate'
    sys_info <- Sys.info()['nodename']
    machine_index <- substr(sys_info, 1, 2)
      if (machine_index == 'gl' | machine_index == 'as' | machine_index == 'gs' | machine_index == 'da'){
        path <- '/gpfs/scratch/bsc32/MN4/bsc32/bsc32693/data_amd/recon/era5land/daily_mean/$var$_f1h/$var$_$year$$month$.nc'
      } else {
        path <- '/esarchive/recon/ecmwf/era5land/daily_mean/$var$_f1h/$var$_$year$$month$.nc'
      }
      
    #### TAS ####
      obs_tas <- startR::Start(dat = path, var = 'tas',
                           lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                           lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                           year = paste0(config$years), month = 'all', time = 'all', time_across = 'month', 
                           merge_across_dims = TRUE, merge_across_dims_narm = TRUE,
                           synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                           return_vars = list(lat = NULL, lon = NULL, time = c('month','year')), lon_var = 'lon', lat_var = 'lat',
                           lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                           num_procs = 1, retrieve = TRUE)
    
      obs_lons <- attr(obs_tas,'Variables')$common[['lon']]
      obs_lats <- attr(obs_tas,'Variables')$common[['lat']]
      dates_obs_tas <- attr(obs_tas,'Variables')$common$time
      indices_years <- which(config$years %in% years)
      obs_tas <- multiApply::Apply(data = obs_tas, target_dims = 'year', 
                                   fun = function(data){zoo::rollmean(x = as.vector(data), k = length(fyears), fill = NULL, align = 'left')}, 
                                   output_dims = 'year', ncores = config$ncores)$output1
      obs_tas <- drop(obs_tas)
      obs_lons <- as.vector(obs_lons)
      obs_lats <- as.vector(obs_lats)
      # obs_tas <- s2dv::CDORemap(data_array = obs_tas, lons = obs_lons, lats = obs_lats, grid = grid, method = config$interpolation_method, crop = c(config$regions[[region]]$lon_min, config$regions[[region]]$lon_max, config$regions[[region]]$lat_min, config$regions[[region]]$lat_max), force_remap = TRUE)
      # obs_tas <- obs_tas$data_array
      obs_tas <- Reorder(data = obs_tas, order = c('year','lon','lat','time'))
      names(dim(obs_tas))[1] <- 'sdate'

      indices_remove <- apply(dates_obs_tas, 1, function(x) {which(is.na(x) == T)})
      if (config$years[1] %% 4 == 0 && (config$years[1] %% 100 != 0 || config$years[1] %% 400 == 0)){
        keep_indices <- !(seq_len(dim(obs_tas)['time']) %in% indices_remove[[2]])
      } else {
        keep_indices <- !(seq_len(dim(obs_tas)['time']) %in% indices_remove[[1]])
      }
      obs_tas <- ClimProjDiags::Subset(x = obs_tas, along = 'time', indices = keep_indices, drop = FALSE)
      print('dim obs_tas')
      print(dim(obs_tas))
    
      ##### RSDS #####
      obs_rsds <- startR::Start(dat = path, var = 'rsds',
                                lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                                lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                                year = paste0(config$years), month = 'all', time = 'all',
                                time_across = 'month', merge_across_dims = TRUE, merge_across_dims_narm = TRUE,
                                synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                                return_vars = list(lat = NULL, lon = NULL, time = c('month','year')), lon_var = 'lon', lat_var = 'lat',
                                lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                                num_procs = 1, retrieve = TRUE)
      
      dates_obs_rsds <- attr(obs_rsds,'Variables')$common$time
      obs_rsds <- multiApply::Apply(data = obs_rsds, target_dims = 'year', 
                                    fun = function(data){zoo::rollmean(x = as.vector(data), k = length(fyears), fill = NULL, align = 'left')}, 
                                    output_dims = 'year', ncores = config$ncores)$output1
      obs_rsds <- drop(obs_rsds)
      obs_rsds <- s2dv::CDORemap(data_array = obs_rsds, lons = obs_lons, lats = obs_lats, grid = grid, method = config$interpolation_method, crop = c(config$regions[[region]]$lon_min, config$regions[[region]]$lon_max, config$regions[[region]]$lat_min, config$regions[[region]]$lat_max), force_remap = TRUE)
      obs_lons <- obs_rsds$lon
      obs_lats <- obs_rsds$lat
      obs_rsds <- obs_rsds$data_array
      obs_rsds <- Reorder(data = obs_rsds, order = c('year','lon','lat','time'))
      names(dim(obs_rsds))[1] <- 'sdate'
      
      indices_remove <- apply(dates_obs_rsds, 1, function(x) {which(is.na(x) == T)})
      if (config$years[1] %% 4 == 0 && (config$years[1] %% 100 != 0 || config$years[1] %% 400 == 0)){
        keep_indices <- !(seq_len(dim(obs_rsds)['time']) %in% indices_remove[[2]])
      } else {
        keep_indices <- !(seq_len(dim(obs_rsds)['time']) %in% indices_remove[[1]])
      }
      obs_rsds <- ClimProjDiags::Subset(x = obs_rsds, along = 'time', indices = keep_indices, drop = FALSE)
      dates_obs <- ClimProjDiags::Subset(x = dates_obs_rsds, along = 'time', indices = keep_indices, drop = FALSE)
      print('dim obs_rsds')
      print(dim(obs_rsds))
      
      if (model == 'HadGEM3-GC3.1-MM'){
        obs_tas <- obs_tas[,,,1:360]
        obs_rsds <- obs_rsds[,,,1:360]
      } 

    if (identical(model,'MRI-ESM2-0')) { #& grepl(pattern = '_djf', x = variable) & any(fyears > 4)
      indices_fyears <- fyears[-which(fyears > 4)]
    } else if (identical(model,'MRI-ESM2-0') & any(fyears > 5)){
      indices_fyears <- fyears[-which(fyears > 5)]
    } else {indices_fyears <- fyears}
      indices_fyears <- 1
    
    if (length(fyears) == 1){fyears_string <- paste0('fyear',fyears[1])} else {fyears_string <- paste0('fyears',fyears[1],'-',fyears[length(fyears)])}
    sdates <- config$sdates[1] : (config$years[length(config$years)] - as.integer(fyears[length(fyears)]))
    years <- (sdates[1] + as.integer(fyears[1])) : config$years[length(config$years)]

    for (fy in indices_fyears){
        tas <- startR_calls_daily(dataset = model, variables = 'tas', fyears = fy, config = config, lon_min = config$regions[[region]]$lon_min, lon_max = config$regions[[region]]$lon_max,
                                  lat_min = config$regions[[region]]$lat_min, lat_max = config$regions[[region]]$lat_max, retrieve = TRUE, members = members)

        tas$data <- ClimProjDiags::Subset(x = tas$data, along = 'sdate', indices = which(config$sdates %in% sdates), drop = TRUE)
        dates_dcpp_tas <- tas$dates
        lon_tas <- as.vector(tas$lon)
        lat_tas <- as.vector(tas$lat)
        tas <- s2dv::CDORemap(data_array = tas$data, lons = tas$lon, lats = tas$lat, grid = grid, method = config$interpolation_method, crop = c(config$regions[[region]]$lon_min, config$regions[[region]]$lon_max, config$regions[[region]]$lat_min, config$regions[[region]]$lat_max), force_remap = TRUE)
        lon_tas <- tas$lon
        lat_tas <- tas$lat
        tas <- tas$data_array
        tas <- drop(tas)

      if (model == 'HadGEM3-GC3.1-MM'){
        days <- 360
      } else {
        days <- 365
      }

      if (identical(fy,indices_fyears[1])){
        dcpp_tas <- array(data = NA, dim = c('sdate' = length(config$sdates), 'lon' = length(lon_tas), 'lat' = length(lat_tas), time = days, fyear = length(indices_fyears))) 
      }
      dcpp_tas[,,,,which(indices_fyears==fy)] <- s2dv::Reorder(data = tas, order = c('sdate','lon','lat','time'))
    }
    dcpp_tas <- multiApply::Apply(data = dcpp_tas, target_dims = c('fyear'), fun = mean, na.rm = FALSE, ncores = config$ncores)$output1
    print('dim dcpp_tas')
    print(dim(dcpp_tas))

    for (fy in indices_fyears){
      rsds <- startR_calls_daily(dataset = model, variables = 'rsds', fyears = fy, config = config, lon_min = config$regions[[region]]$lon_min, lon_max = config$regions[[region]]$lon_max,
                                 lat_min = config$regions[[region]]$lat_min, lat_max = config$regions[[region]]$lat_max, retrieve = TRUE, members = members)

      rsds$data <- ClimProjDiags::Subset(x = rsds$data, along = 'sdate', indices = which(config$sdates %in% sdates), drop = TRUE)
      dates_dcpp_rsds <- rsds$dates
      lon_rsds <- as.vector(rsds$lon)
      lat_rsds <- as.vector(rsds$lat)
      rsds <- s2dv::CDORemap(data_array = rsds$data, lons = lon_rsds, lats = lat_rsds, grid = grid, method = config$interpolation_method, crop = c(config$regions[[region]]$lon_min, config$regions[[region]]$lon_max, config$regions[[region]]$lat_min, config$regions[[region]]$lat_max), force_remap = TRUE)
      lon_rsds <- rsds$lon
      lat_rsds <- rsds$lat
      rsds <- rsds$data_array
      rsds <- drop(rsds)
      
      if (model == 'HadGEM3-GC3.1-MM'){
        days <- 360
      } else {
        days <- 365
      }
      if (identical(fy,indices_fyears[1])){
        dcpp_rsds <- array(data = NA, dim = c('sdate' = length(config$sdates), 'lon' = length(lon_rsds), 'lat' = length(lat_rsds), time = days, fyear = length(indices_fyears)))
      }
      dcpp_rsds[,,,,which(indices_fyears==fy)] <- s2dv::Reorder(data = rsds, order = c('sdate','lon','lat','time'))
    }
    dcpp_rsds <- multiApply::Apply(data = dcpp_rsds, target_dims = c('fyear'), fun = mean, na.rm = FALSE, ncores = config$ncores)$output1
    print('dim dcpp_tas')
    print(dim(dcpp_tas))
    rm(rsds, tas)
    names(dim(obs_rsds))[1] <- 'sdate'
    sdate_dim <- dim(obs_rsds)['sdate']
    cross <- .make.eval.train.dexes(eval.method = 'leave-one-out', amt.points = sdate_dim,
                                    amt.points_cor = NULL, k = 1, tail.out = FALSE)
    print('Calibration')
    months <- format(dates_obs, "%m")
    seasons <- list(
      DJF = c("12", "01", "02"),
      MAM = c("03", "04", "05"),
      JJA = c("06", "07", "08"),
      SON = c("09", "10", "11"),
      Annual = c('01','02','03','04','05','06','07','08','09','10','11','12')
    )
    dates_first_year_au <- dates_obs[format(dates_obs, "%Y") == config$sdates[2]]
    seasons_masks <- lapply(seasons, function(seasons_months) {
      format(dates_first_year_au, "%m") %in% seasons_months
    })
    for (t in 1:sdate_dim){
      print(t)
      obs_tas_tr <- ClimProjDiags::Subset(x = obs_tas, along = 'sdate', indices = cross[[t]]$train.dexes, drop = 'selected')
      obs_rsds_tr <- ClimProjDiags::Subset(x = obs_rsds, along = 'sdate', indices = cross[[t]]$train.dexes, drop = 'selected')
      obs_tas_ev <- ClimProjDiags::Subset(x = obs_tas, along = 'sdate', indices = cross[[t]]$eval.dexes, drop = FALSE)
      obs_rsds_ev <- ClimProjDiags::Subset(x = obs_rsds, along = 'sdate', indices = cross[[t]]$eval.dexes, drop = FALSE)
      dcpp_tas_tr <- ClimProjDiags::Subset(x = dcpp_tas, along = 'sdate', indices = cross[[t]]$train.dexes, drop = 'selected')
      dcpp_rsds_tr <- ClimProjDiags::Subset(x = dcpp_rsds, along = 'sdate', indices = cross[[t]]$train.dexes, drop = 'selected')
      dcpp_tas_ev <- ClimProjDiags::Subset(x = dcpp_tas, along = 'sdate', indices = cross[[t]]$eval.dexes, drop = FALSE)
      dcpp_rsds_ev <- ClimProjDiags::Subset(x = dcpp_rsds, along = 'sdate', indices = cross[[t]]$eval.dexes, drop = FALSE)
      obs_rsds_tr_wi <- add_window_dim(obs_rsds_tr)
      dcpp_rsds_tr_wi <- add_window_dim(dcpp_rsds_tr)
      dcpp_rsds_ev <- QuantileMapping(exp = dcpp_rsds_tr_wi, obs = obs_rsds_tr_wi,
                                       exp_cor = dcpp_rsds_ev,
                                       na.rm = TRUE,  memb_dim = NULL, sdate_dim = 'sdate',
                                       window_dim = 'window',
                                       ncores = config$ncores, method = 'QUANT', qstep = 0.01)
      print('calibration rsds_ev done')
      dcpp_rsds_tr <- QuantileMapping(exp = dcpp_rsds_tr_wi, obs = obs_rsds_tr_wi,
                                      exp_cor = dcpp_rsds_tr,
                                      na.rm = TRUE,  memb_dim = NULL, sdate_dim = 'sdate',
                                      window_dim = 'window',
                                      ncores = config$ncores, method = 'QUANT', qstep = 0.01)
      print('calibration rsds_tr done')
      rm(dcpp_rsds_tr_wi,obs_rsds_tr_wi)
      obs_tas_tr_wi <- add_window_dim(obs_tas_tr)
      dcpp_tas_tr_wi <- add_window_dim(dcpp_tas_tr)
      dcpp_tas_ev <- QuantileMapping(exp = dcpp_tas_tr_wi, obs = obs_tas_tr_wi,
                                        exp_cor = dcpp_tas_ev,
                                        na.rm = TRUE,  memb_dim = NULL, sdate_dim = 'sdate',
                                        window_dim = 'window',
                                        ncores = config$ncores, method = 'QUANT', qstep = 0.01)
      print('calibration tas_ev done')
      dcpp_tas_tr <- QuantileMapping(exp = dcpp_tas_tr_wi, obs = obs_tas_tr_wi,
                                     exp_cor = dcpp_tas_tr,
                                     na.rm = TRUE,  memb_dim = NULL, sdate_dim = 'sdate',
                                     window_dim = 'window',
                                     ncores = config$ncores, method = 'QUANT', qstep = 0.01)
      print('calibration tas_tr done')
      rm(dcpp_tas_tr_wi,obs_tas_tr_wi)
      dcpp_tas_ev <- Reorder(data = dcpp_tas_ev, order = c('sdate','lon','lat','time'))
      
      if (agregation == 'seasons'){
        if (t == 1){
          pv_dcpp_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_dcpp_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_dcpp_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_dcpp_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_dcpp_Annual <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_dcpp_probs_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_dcpp_probs_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_dcpp_probs_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_dcpp_probs_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_dcpp_probs_Annual <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_obs_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_obs_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_obs_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_obs_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_obs_Annual <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          pv_obs_probs_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_obs_probs_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_obs_probs_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_obs_probs_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          pv_obs_probs_Annual <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3], bin = 3))
          n_effective_dcpp_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_dcpp_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_dcpp_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_dcpp_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_dcpp_Annual <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_obs_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_obs_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_obs_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_obs_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_effective_obs_Annual <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_dcpp_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_dcpp_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_dcpp_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_dcpp_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_dcpp_Annual<- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_obs_DJF <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_obs_MAM <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_obs_JJA <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_obs_SON <- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
          n_t45_obs_Annual<- array(NA, dim = c(sdate_dim, dim(dcpp_tas_ev)[2:3]))
        }
        for (season in names(seasons)){
          print(season)
          seasons_mask <- seasons_masks[[season]]
          dcpp_tas_ev_sea <- dcpp_tas_ev[, , ,seasons_mask]
          dcpp_tas_tr_sea <- dcpp_tas_tr[, , ,seasons_mask]
          obs_tas_ev_sea <- obs_tas_ev[, , ,seasons_mask]
          obs_tas_tr_sea <- obs_tas_tr[, , ,seasons_mask]
          dcpp_rsds_ev_sea <- dcpp_rsds_ev[, , ,seasons_mask]
          dcpp_rsds_tr_sea <- dcpp_rsds_tr[, , ,seasons_mask]
          obs_rsds_ev_sea <- obs_rsds_ev[, , ,seasons_mask]
          obs_rsds_tr_sea <- obs_rsds_tr[, , ,seasons_mask]
          n_effective_dcpp <- apply(dcpp_rsds_ev_sea, c(1, 2), function(x) {
            sum(x > 208, na.rm = TRUE)
          })
          n_effective_obs <- apply(obs_rsds_ev_sea, c(1, 2), function(x) {
            sum(x > 208, na.rm = TRUE)
          })
          n_t45_dcpp <- apply(dcpp_tas_ev_sea, c(1, 2), function(x) {
            sum(x > 318, na.rm = TRUE)
          })
          n_t45_obs <- apply(obs_tas_ev_sea, c(1, 2), function(x) {
            sum(x > 318, na.rm = TRUE)
          })

          dcpp_tas_ev_sea <- MeanDims(data = dcpp_tas_ev_sea, dims = 'time', na.rm = TRUE)
          dcpp_tas_ev_sea <- InsertDim(data = dcpp_tas_ev_sea, posdim = 1, lendim = 1, name = 'sdate')
          dcpp_tas_tr_sea <- MeanDims(data = dcpp_tas_tr_sea, dims = 'time', na.rm = TRUE)
          obs_tas_ev_sea <- MeanDims(data = obs_tas_ev_sea, dims = 'time', na.rm = TRUE)
          obs_tas_ev_sea <- InsertDim(data = obs_tas_ev_sea, posdim = 1, lendim = 1, name = 'sdate')
          obs_tas_tr_sea <- MeanDims(data = obs_tas_tr_sea, dims = 'time', na.rm = TRUE)
          dcpp_rsds_ev_sea <- MeanDims(data = dcpp_rsds_ev_sea, dims = 'time', na.rm = TRUE)
          dcpp_rsds_ev_sea <- InsertDim(data = dcpp_rsds_ev_sea, posdim = 1, lendim = 1, name = 'sdate')
          dcpp_rsds_tr_sea <- MeanDims(data = dcpp_rsds_tr_sea, dims = 'time', na.rm = TRUE)
          obs_rsds_ev_sea <- MeanDims(data = obs_rsds_ev_sea, dims = 'time', na.rm = TRUE)
          obs_rsds_ev_sea <- InsertDim(data = obs_rsds_ev_sea, posdim = 1, lendim = 1, name = 'sdate')
          obs_rsds_tr_sea <- MeanDims(data = obs_rsds_tr_sea, dims = 'time', na.rm = TRUE)
          if (method == 'first'){
            pv_dcpp <- multiApply::Apply(data = list(dcpp_tas_ev_sea, dcpp_rsds_ev_sea), target_dims = c('sdate'), fun =  solar2CF, ncores = config$ncores)$output1
            pv_dcpp_tr <- multiApply::Apply(data = list(dcpp_tas_tr_sea, dcpp_rsds_tr_sea), target_dims = c('sdate'), fun =  solar2CF, ncores = config$ncores)$output1
            pv_obs <- multiApply::Apply(data = list(obs_tas_ev_sea, obs_rsds_ev_sea), target_dims = c('sdate'), fun =  solar2CF, ncores = config$ncores)$output1
            pv_obs_tr <- multiApply::Apply(data = list(obs_tas_tr_sea, obs_rsds_tr_sea), target_dims = c('sdate'), fun =  solar2CF, ncores = config$ncores)$output1
          } else if (method == 'second'){
            pv_dcpp <- multiApply::Apply(data = list(dcpp_tas_ev_sea, dcpp_rsds_ev_sea), target_dims = c('sdate'), fun =  PV_pot, ncores = config$ncores)$output1
            pv_dcpp_tr <- multiApply::Apply(data = list(dcpp_tas_tr_sea, dcpp_rsds_tr_sea), target_dims = c('sdate'), fun =  PV_pot, ncores = config$ncores)$output1
            pv_obs <- multiApply::Apply(data = list(obs_tas_ev_sea, obs_rsds_ev_sea), target_dims = c('sdate'), fun =  PV_pot, ncores = config$ncores)$output1
            pv_obs_tr <- multiApply::Apply(data = list(obs_tas_tr, obs_rsds_tr), target_dims = c('sdate'), fun =  PV_pot, ncores = config$ncores)$output1
          }
          pv_dcpp <- Reorder(data = pv_dcpp, order = c('sdate','lon','lat'))
          pv_obs <- Reorder(data = pv_obs, order = c('sdate','lon','lat'))
          pv_dcpp_tr <- Reorder(data = pv_dcpp_tr, order = c('sdate','lon','lat'))
          pv_obs_tr <- Reorder(data = pv_obs, order = c('sdate','lon','lat'))
          lims_ano_obs_tr <- multiApply::Apply(pv_obs_tr, target_dims = 'sdate',
                                               fun = function(x) {quantile(as.vector(x), c(1/3, 2/3), na.rm = TRUE)},
                                               output_dims = 'bin', ncores = config$ncores)$output1
          lims_ano_dcpp_tr <- multiApply::Apply(pv_dcpp_tr, target_dims = c('sdate'),
                                                fun = function(x) {quantile(as.vector(x), c(1/3, 2/3), na.rm = TRUE)},
                                                output_dims = 'bin', ncores = config$ncores)$output1
          
          pv_dcpp_probs_ev <- GetProbs_2(pv_dcpp, time_dim = 'sdate', 
                                      prob_thresholds = NULL,
                                      bin_dim_abs = 'bin', 
                                      indices_for_quantiles = NULL,
                                      memb_dim = NULL, abs_thresholds = lims_ano_dcpp_tr,
                                      ncores = config$ncores)
          
          obs_probs_ev <- GetProbs_2(pv_obs, time_dim = 'sdate',
                                     prob_thresholds = NULL,
                                     bin_dim_abs = 'bin',
                                     indices_for_quantiles = NULL,
                                     memb_dim = NULL, abs_thresholds = lims_ano_obs_tr,
                                     ncores = config$ncores)
          
          pv_obs_probs_ev <- Reorder(data = pv_dcpp_probs_ev, order = c('sdate','lon','lat','bin'))
          obs_probs_ev <- Reorder(data = obs_probs_ev, order = c('sdate','lon','lat','bin'))
          
          if (season == 'DJF'){
            pv_dcpp_DJF[t,,] <- pv_dcpp
            pv_obs_DJF[t,,] <- pv_obs
            pv_dcpp_probs_DJF[t,,,] <- pv_dcpp_probs_ev
            pv_obs_probs_DJF[t,,,] <- obs_probs_ev
            n_effective_dcpp_DJF[t,,] <- n_effective_dcpp
            n_effective_obs_DJF[t,,] <- n_effective_obs
            n_t45_dcpp_DJF[t,,] <- n_t45_dcpp
            n_t45_obs_DJF[t,,] <- n_t45_obs
          } else if (season == 'MAM'){
            pv_dcpp_MAM[t,,] <- pv_dcpp
            pv_obs_MAM[t,,] <- pv_obs
            pv_dcpp_probs_MAM[t,,,] <- pv_dcpp_probs_ev
            pv_obs_probs_MAM[t,,,] <- obs_probs_ev
            n_effective_dcpp_MAM[t,,] <- n_effective_dcpp
            n_effective_obs_MAM[t,,] <- n_effective_obs
            n_t45_dcpp_MAM[t,,] <- n_t45_dcpp
            n_t45_obs_MAM[t,,] <- n_t45_obs
          } else if (season == 'JJA'){
            pv_dcpp_JJA[t,,] <- pv_dcpp
            pv_obs_JJA[t,,] <- pv_obs
            pv_dcpp_probs_JJA[t,,,] <- pv_dcpp_probs_ev
            pv_obs_probs_JJA[t,,,] <- obs_probs_ev
            n_effective_dcpp_JJA[t,,] <- n_effective_dcpp
            n_effective_obs_JJA[t,,] <- n_effective_obs
            n_t45_dcpp_JJA[t,,] <- n_t45_dcpp
            n_t45_obs_JJA[t,,] <- n_t45_obs
          } else if (season == 'SON'){
            pv_dcpp_SON[t,,] <- pv_dcpp
            pv_obs_SON[t,,] <- pv_obs
            pv_dcpp_probs_SON[t,,,] <- pv_dcpp_probs_ev
            pv_obs_probs_SON[t,,,] <- obs_probs_ev
            n_effective_dcpp_SON[t,,] <- n_effective_dcpp
            n_effective_obs_SON[t,,] <- n_effective_obs
            n_t45_dcpp_SON[t,,] <- n_t45_dcpp
            n_t45_obs_SON[t,,] <- n_t45_obs
          } else if (season == 'Annual'){
            pv_dcpp_Annual[t,,] <- pv_dcpp
            pv_obs_Annual[t,,] <- pv_obs
            pv_dcpp_probs_Annual[t,,,] <- pv_dcpp_probs_ev
            pv_obs_probs_Annual[t,,,] <- obs_probs_ev
            n_effective_dcpp_Annual[t,,] <- n_effective_dcpp
            n_effective_obs_Annual[t,,] <- n_effective_obs
            n_t45_dcpp_Annual[t,,] <- n_t45_dcpp
            n_t45_obs_Annual[t,,] <- n_t45_obs
          }
        }
      }
    }
    

    print('FINISHED :D')
    saveRDS(object = list(pv_dcpp_DJF = pv_dcpp_DJF,
                          pv_dcpp_MAM = pv_dcpp_MAM,
                          pv_dcpp_JJA = pv_dcpp_JJA,
                          pv_dcpp_SON = pv_dcpp_SON,
                          pv_dcpp_Annual = pv_dcpp_Annual,
                          pv_dcpp_probs_DJF = pv_dcpp_probs_DJF,
                          pv_dcpp_probs_MAM = pv_dcpp_probs_MAM,
                          pv_dcpp_probs_JJA = pv_dcpp_probs_JJA,
                          pv_dcpp_probs_SON = pv_dcpp_probs_SON,
                          pv_dcpp_probs_Annual = pv_dcpp_probs_Annual,
                          pv_obs_DJF = pv_obs_DJF, 
                          pv_obs_MAM = pv_obs_MAM,
                          pv_obs_JJA = pv_obs_JJA,
                          pv_obs_SON = pv_obs_SON,
                          pv_obs_Annual = pv_obs_Annual,
                          pv_obs_probs_DJF = pv_obs_probs_DJF,
                          pv_obs_probs_MAM = pv_obs_probs_MAM,
                          pv_obs_probs_JJA = pv_obs_probs_JJA,
                          pv_obs_probs_SON = pv_obs_probs_SON,
                          pv_obs_probs_Annual = pv_obs_probs_Annual,
                          n_effective_dcpp_DJF = n_effective_dcpp_DJF,
                          n_effective_dcpp_MAM = n_effective_dcpp_MAM,
                          n_effective_dcpp_JJA = n_effective_dcpp_JJA,
                          n_effective_dcpp_SON = n_effective_dcpp_SON,
                          n_effective_dcpp_Annual = n_effective_dcpp_Annual,
                          n_effective_obs_DJF = n_effective_obs_DJF,
                          n_effective_obs_MAM = n_effective_obs_MAM,
                          n_effective_obs_JJA = n_effective_obs_JJA,
                          n_effective_obs_SON = n_effective_obs_SON,
                          n_effective_obs_Annual = n_effective_obs_Annual,
                          n_t45_dcpp_DJF = n_t45_dcpp_DJF,
                          n_t45_dcpp_MAM = n_t45_dcpp_MAM,
                          n_t45_dcpp_JJA = n_t45_dcpp_JJA,
                          n_t45_dcpp_SON = n_t45_dcpp_SON,
                          n_t45_dcpp_Annual = n_t45_dcpp_Annual,
                          n_t45_obs_DJF = n_t45_obs_DJF,
                          n_t45_obs_MAM = n_t45_obs_MAM,
                          n_t45_obs_JJA = n_t45_obs_JJA,
                          n_t45_obs_SON = n_t45_obs_SON,
                          n_t45_obs_Annual = n_t45_obs_Annual,
                          lon = obs_lons,
                          lat = obs_lats,
                          config = config,
                          dates = dates_dcpp_tas),
            file = paste0(config$capacity_factors_models,'solar_capacity_factor_',model,'_',fyears_string,'_',region,'_',members,'_',method,'.rds'))
    
    
  }
