setwd('/esarchive/scratch/smoreno/gitlab/capacity_factors/')
source('config.R')
source('/esarchive/scratch/smoreno/gitlab/capacity_factors/simpl_wind_capacity_factors.R')
# args <- commandArgs(trailingOnly = TRUE)
# model <- args[1]
# IEC_class <- args[2]
# member <- args[3]
models <- config$models
region <- 'Iberia'
fperiods <- '1'
model <- 'EC-Earth3-i4'
agregation <- 'seasons'
retrieve <- FALSE
IEC_class <- 'I'
member <- 'r2i4p1f1'
if (region == 'Europe'){
  grid <- config$grid_25
} else { 
  grid <- config$grid_down
}

# config$years <- 1990:1992
# config$sdates <- 1989:1991
# config$regions = list('Iberia' = list('lon_min' = 0, 'lon_max' = 0.1, 'lat_min' = 41, 'lat_max' = 41.2))
if (identical(models,'all')){
  models <- c(config$models,config$multimodels)
} else {
  models <- unlist(strsplit(x = models, split = ','))
}
if (identical(fperiods,'all')){
  fperiods <- config$fperiods
} else {
  aux <- unlist(strsplit(x = fperiods, split = ','))
  fperiods <- list()
  for (i in 1:length(aux)){
    auxi <- unlist(strsplit(x = aux[i], split = '-'))
    fperiods[[i]] <- seq(from = auxi[1], to = auxi[length(auxi)], by = 1)
  }
}

  for (fyears in fperiods){
    time_starting_exec <- proc.time()
    
    if (length(fyears) == 1){fyears_string <- paste0('fyear',fyears[1])} else {fyears_string <- paste0('fyears',fyears[1],'-',fyears[length(fyears)])}
    sdates <- config$sdates[1] : (config$years[length(config$years)] - as.integer(fyears[length(fyears)]))
    years <- (sdates[1] + as.integer(fyears[1])) : config$years[length(config$years)]
    # indices_for_clim <- seq(from = (config$reference_period[1]-years[1]+1), length.out = length(config$reference_period)-length(fyears)+1)

    print(paste0('Starting ',model,' - ',fyears_string))
    
    ################################################################################################
    #################################### Loading the data ##########################################
    ################################################################################################
    
    print('Loading the data...')
    
    time_dim <- 'sdate'
    sys_info <- Sys.info()['nodename']
    machine_index <- substr(sys_info, 1, 2)
      if (machine_index == 'gl' | machine_index == 'as' | machine_index == 'gs' | machine_index == 'da'){
        path <- '/gpfs/scratch/bsc32/bsc32693/scratch/recon/era5/1hourly/$var$-r1440x721cds/$var$_$year$$month$.nc'
        path_mask <- '/gpfs/scratch/bsc32/MN4/bsc32/bsc32693/'
        era5_path <- '/gpfs/projects/bsc32/esarchive_cache/recon/ecmwf/era5/monthly_mean/$var$_f1h-r1440x721cds/$var$_$year$$month$.nc'
        gwa100_file <- '/gpfs/scratch/bsc32/bsc32693/scratch/capacity_outputs/GWA_wspd100m_t170grid.nc'
      } else {
        path <- '/esarchive/recon/ecmwf/era5/1hourly/$var$-r1440x721cds/$var$_$year$$month$.nc'
        path_mask <- '/esarchive/recon/ecmwf/era5/constant/lsm-r1440x721cds/'
        era5_path <- '/esarchive/recon/ecmwf/era5/monthly_mean/$var$_f1h-r1440x721cds/$var$_$year$$month$.nc'  
        gwa100_file <- "/esarchive/scratch/smoreno/capacity_outputs/GWA_$var$m_t170grid.nc"
      }

    total_hours <- 8928
    desired_hours <- c(0, 6, 12, 18)
    selected_indices <- NULL
    for (hour in desired_hours) {
          selected_indices <- c(selected_indices, seq(hour + 1, total_hours, by = 24))
    }
      obs_uas <- startR::Start(dat = path, var = 'uas',
                           lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                           lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                           year = paste0(config$years), month = 'all', time = selected_indices,
                           time_across = 'month', merge_across_dims = TRUE, merge_across_dims_narm = TRUE,
                           synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                           return_vars = list(lat = NULL, lon = NULL, time = c('month','year')), lon_var = 'lon', lat_var = 'lat',
                           lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                           transform = CDORemapper,
                           transform_extra_cells = 2,
                           transform_params = list(grid = config$grid_down,
                                                   method = 'conservative'),
                           transform_vars = c('lat', 'lon'),
                           num_procs = 1, retrieve = retrieve)
      
      obs_vas <- startR::Start(dat = path, var = 'vas',
                               lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                               lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                               year = paste0(config$years), month = 'all', time = selected_indices,
                               time_across = 'month', merge_across_dims = TRUE, merge_across_dims_narm = TRUE,
                               synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                               return_vars = list(lat = NULL, lon = NULL, time = c('month','year')), lon_var = 'lon', lat_var = 'lat',
                               lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                               transform = CDORemapper,
                               transform_extra_cells = 2,
                               transform_params = list(grid = config$grid_down,
                                                       method = 'conservative'),
                               transform_vars = c('lat', 'lon'),
                               num_procs = 1, retrieve = retrieve)
    
      dates_obs <- attr(obs_vas,"Variables")$common$time
      lon <- attr(obs_vas,'Variables')$common[['lon']]
      lat <- attr(obs_vas,'Variables')$common[['lat']]
      
      era5_wind <- startR::Start(dat = era5_path, var = 'sfcWind',
                                 lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                                 lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                                 year = paste0(config$years), month = 'all', time = 'all',
                                 synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                                 return_vars = list(lat = NULL, lon = NULL), lon_var = 'lon', lat_var = 'lat',
                                 lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                                 transform = CDORemapper,
                                 transform_extra_cells = 2,
                                 transform_params = list(grid = config$grid_down,
                                                         method = 'conservative'),
                                 transform_vars = c('lat', 'lon'),
                                 num_procs = 1, retrieve = retrieve)

      gwa <- startR::Start(dat = gwa100_file, var = 'WSPD100',
                           lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                           lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                           synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                           return_vars = list(lat = NULL, lon = NULL), lon_var = 'lon', lat_var = 'lat',
                           lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                           transform = CDORemapper,
                           transform_extra_cells = 2,
                           transform_params = list(grid = config$grid_down,
                                                   method = 'conservative'),
                           transform_vars = c('lat', 'lon'),
                           num_procs = 1, retrieve = retrieve)
      
      mask_ori <- startR::Start(dat = paste0(path_mask,'$var$.nc'), var = 'sftof',
                                lon = values(list(config$regions[[region]]$lon_min,config$regions[[region]]$lon_max)),
                                lat = values(list(config$regions[[region]]$lat_min,config$regions[[region]]$lat_max)),
                                synonims = list(lat = c('lat','latitude'), lon = c('lon','longitude')),
                                return_vars = list(lat = NULL, lon = NULL), lon_var = 'lon', lat_var = 'lat',
                                lat_reorder = Sort(decreasing = FALSE), lon_reorder = CircularSort(-180,180),
                                transform = CDORemapper,
                                transform_extra_cells = 2,
                                transform_params = list(grid = config$grid_down,
                                                        method = 'conservative'),
                                transform_vars = c('lat', 'lon'),
                                num_procs = 1, retrieve = retrieve)
      
      
    if (identical(model,'MRI-ESM2-0')) {
      indices_fyears <- fyears[-which(fyears > 4)]
    } else if (identical(model,'MRI-ESM2-0') & any(fyears > 5)){
      indices_fyears <- fyears[-which(fyears > 5)]
    } else {indices_fyears <- fyears}
      indices_fyears <- 1

      dcpp <- startR_calls_subdaily_wind(model = model,fy = fy, config = config, lon_min = config$regions[[region]]$lon_min, lon_max = config$regions[[region]]$lon_max, 
                                      lat_min = config$regions[[region]]$lat_min, lat_max = config$regions[[region]]$lat_max, member = member, machine_index = machine_index,
                                      retrieve = retrieve)
      }
      
          output_dims <- list(cf_dcpp_DJF = 'sdate',
                              cf_dcpp_MAM = 'sdate',
                              cf_dcpp_JJA = 'sdate',
                              cf_dcpp_SON = 'sdate',
                              cf_dcpp_Annual = 'sdate',
                              cf_obs_DJF = 'sdate',
                              cf_obs_MAM = 'sdate',
                              cf_obs_JJA = 'sdate',
                              cf_obs_SON = 'sdate',
                              cf_obs_Annual = 'sdate',
                              cf_probs_DJF = c('bin','sdate'),
                              cf_probs_MAM = c('bin','sdate'),
                              cf_probs_JJA = c('bin','sdate'),
                              cf_probs_SON = c('bin','sdate'),
                              cf_probs_Annual = c('bin','sdate'),
                              # days_dcpp_DJF = 'sdate',
                              # days_dcpp_MAM = 'sdate',
                              # days_dcpp_JJA = 'sdate',
                              # days_dcpp_SON = 'sdate',
                              # days_dcpp_Annual = 'sdate',
                              # days_obs_DJF = 'sdate',
                              # days_obs_MAM = 'sdate',
                              # days_obs_JJA = 'sdate',
                              #subdays_obs_SON = 'sdate',
                              #subdays_obs_Annual = 'sdate',
                              subdays_dcpp_DJF = 'sdate',
                              subdays_dcpp_MAM = 'sdate',
                              subdays_dcpp_JJA = 'sdate',
                              subdays_dcpp_SON = 'sdate',
                              subdays_dcpp_Annual = 'sdate',
                              subdays_obs_DJF = 'sdate',
                              subdays_obs_MAM = 'sdate',
                              subdays_obs_JJA = 'sdate',
                              subdays_obs_SON = 'sdate',
                              subdays_obs_Annual = 'sdate'
          )

          target_dims <-  list(obs_uas = c('year', 'time'),
                               obs_vas = c('year', 'time'),
                               dcpp_uas = c('sdate','time','member'),
                               dcpp_vas = c('sdate','time','member'),
                               era5_wind = c('year','month'),
                               mask_ori = c('var'),
                               gwa_spd = c('var'))
          
          if (isTRUE(retrieve)) {
            output <- multiApply::Apply(data = list(obs_uas = obs_uas, 
                                                    obs_vas = obs_vas, 
                                                    dcpp_uas = dcpp$uas, 
                                                    dcpp_vas = dcpp$vas, 
                                                    era5_wind = era5_wind, 
                                                    mask_ori = mask_ori, #InsertDim(data = mask_ori[,,1:2,1:2], posdim = 1, lendim = 1, name = 'var'),
                                                    gwa_spd = gwa #InsertDim(data = gwa_spd[,1:2,1:2], posdim = 1, lendim = 1, name = 'var')
                                                    ),
                                        agregation = agregation,
                                        dates_obs = dates_obs,
                                        dates_dcpp = dcpp$dates,
                                        fyears = 1,
                                        IEC_class = 'I',
                                        model = model,
                                        output_dims = output_dims, 
                                        target_dims = target_dims, 
                                        fun = simpl_wind_capacity_factors, 
                                        config = config, 
                                        ncores = config$ncores)
            
          } else if (isFALSE(retrieve)) {
            
            step <- startR::Step(fun = simpl_wind_capacity_factors,
                                 target_dims = target_dims, 
                                 output_dims = output_dims)
            
            wf <- startR::AddStep(inputs = list(obs_uas = obs_uas, 
                                                obs_vas = obs_vas,
                                                dcpp_uas = dcpp$uas, 
                                                dcpp_vas = dcpp$vas,
                                                era5_wind = era5_wind,
                                                mask_ori = mask_ori,
                                                gwa_spd = gwa),
                                  agregation = agregation,
                                  dates_obs = dates_obs,
                                  dates_dcpp = dcpp$dates,
                                  fyears = 1,
                                  IEC_class = 'I',
                                  model = model,
                                  config = config,
                                  ncores = config$ncores,
                                  step_fun = step)
            
            # if (dataset %in% config$models){
            #   chunks <- list(member = as.numeric(attr(data$data,'Dimensions')['member']),
            #                  lat = 10)
            #   job_wallclock <- '01:00:00'
            # } else {
              chunks <- list(lat = 10, lon = 10) #, member = 2)
              job_wallclock <- '48:00:00'
            # }
            
            output <- startR::Compute(workflow = wf[[1]],
                                      chunks = chunks,
                                      threads_load = 1,
                                      threads_compute = 1,
                                      cluster = list(queue_host = 'nord4.bsc.es',
                                                     queue_type = 'slurm',
                                                     temp_dir = '/gpfs/scratch/bsc32/bsc32693/startR_hpc/',
                                                     cores_per_job = 1, #config$ncores,
                                                     job_wallclock = job_wallclock,
                                                     max_jobs = config$max_jobs,
                                                     # extra_queue_params = list("#SBATCH --constraint='medmem'"),
                                                     extra_queue_params = list(paste0("#SBATCH --cpus-per-task=",config$ncores)),
                                                     bidirectional = FALSE,
                                                     polling_period = 10),
                                      ecflow_suite_dir = '/home/Earth/smoreno/Desktop/startR_local/',
                                      wait = TRUE)
            
          } else {stop('retrieve must be TRUE or FALSE')}
     
    saveRDS(object = list(cf_dcpp_DJF = output$cf_dcpp_DJF,
                          cf_dcpp_MAM = output$cf_dcpp_MAM,
                          cf_dcpp_JJA = output$cf_dcpp_JJA,
                          cf_dcpp_SON = output$cf_dcpp_SON,
                          cf_dcpp_Annual = output$cf_dcpp_Annual,
                          cf_obs_DJF = output$cf_obs_DJF,
                          cf_obs_MAM = output$cf_obs_MAM,
                          cf_obs_JJA = output$cf_obs_JJA,
                          cf_obs_SON = output$cf_obs_SON,
                          cf_obs_Annual = output$cf_obs_Annual,
                          cf_probs_DJF = output$cf_probs_DJF,
                          cf_probs_MAM = output$cf_probs_MAM,
                          cf_probs_JJA = output$cf_probs_JJA,
                          cf_probs_SON = output$cf_probs_SON,
                          cf_probs_Annual = output$cf_probs_Annual,
                          subdays_dcpp_DJF = output$subdays_dcpp_DJF,
                          subdays_dcpp_MAM = output$subdays_dcpp_MAM,
                          subdays_dcpp_JJA = output$subdays_dcpp_JJA,
                          subdays_dcpp_SON = output$subdays_dcpp_SON,
                          subdays_dcpp_Annual = output$subdays_dcpp_Annual,
                          subdays_obs_DJF = output$subdays_obs_DJF,
                          subdays_obs_MAM = output$subdays_obs_MAM,
                          subdays_obs_JJA = output$subdays_obs_JJA,
                          subdays_obs_SON = output$subdays_obs_SON,
                          subdays_obs_Annual = output$subdays_obs_Annual,
                          lon = lon,
                          lat = lat,
                          config = config,
                          dates = dcpp$dates),
            file = paste0(config$capacity_factors_models,'wind_capacity_factor_',model,'_',fyears_string,'_',member,'_',region,'_IEC_class_',IEC_class,'.rds'))
            # file = paste0(config$capacity_factors_models,'wind_capacity_factor_test.rds'))
    
    print('FINISHED :D')
  
