sys_info <- Sys.info()['nodename']
print(sys_info)
machine_index <- substr(sys_info, 1, 2)

if (machine_index == 'bs' | machine_index == 'lo') { #Workstation
path <- '/esarchive/scratch/smoreno/'
path_archives <- path
path_indices <- '/esarchive/scratch/cdelgado/wind_outputs/indices/'
setwd('/esarchive/scratch/smoreno/gitlab/capacity_factors/')
} else{
path <- '/gpfs/scratch/bsc32/MN4/bsc32/bsc32693/data_amd/scratch/'
path_archives <- path
path_indices <- '/gpfs/scratch/bsc32/MN4/bsc32/bsc32693/data_amd/wind_outputs/indices/'
}

print('config capacity factors')
library(startR)
library(s2dv)
library(CSTools)
library(ClimProjDiags)
library(zoo)
library(easyVerification)
library(ncdf4)
library(ggplot2)
# source('startR_calls_variables.R')
# source('startR_calls_extremes.R')fyears
source('startR_calls_daily.R')
source('add_window_dim.R')
# source('startR_calls_extremes.R')
# source('ETCCDI_extremes.R')
source('CorrEno.R')
source('RMSSS_edited.R')
# source('RPSS.R')
# source('CRPSS.R')
# source('ROCSS.R')
source('RandomWalkTest.R')
# source('load_mask.R')
# source('HighestValue_PlotCombinedMap.R')
# source('PlotCombinedDonut.R')
path_gitlab <- paste0(path,'gitlab/')
source(paste0(path_gitlab,'csdownscale/R/Interpolation.R'))
source(paste0(path_gitlab,'csdownscale/R/Analogs.R'))
source(paste0(path_gitlab,'csdownscale/R/Intbc.R'))
source(paste0(path_gitlab,'csdownscale/R/Intlr.R'))
source(paste0(path_gitlab,'csdownscale/R/LogisticReg.R'))
source(paste0(path_gitlab,'csdownscale/R/Utils.R'))
source(paste0(path_gitlab,'cstools/R/CST_Calibration.R'))
source('CFSLR.R')
source('PV_pot.R')
# source('Trend_edited.R')
# source('annual_seasonal_radiation_vars.R')
# source('compute_metrics.R')
# source('compute_downscaling.R')
# source('compute_downscaling_2.R')
# source('topsis.R')
# source('significant_fraction.R')
# source('plotconditions.R')
source('wind2power_duplicate.R')
source('wind2CF_duplicate.R')
source('WindCapacityFactor_duplicate.R')
source('read_pc_duplicate.R')
source('get_fdays.R')
source('wind_capacity_factors.R')
source('startR_calls_subdaily_wind.R')
source('GetProbs_2.R')
source('solar_capacity_factors.R')
source('make_eval_train_dexes_mine.R')

options(bitmapType = 'cairo') ## to avoid error when plotting in Nord3

config <- list(

  variables_path = paste0(path_archives,'focus_outputs/D4.2/variables/'), ## copied from '/esarchive/scratch/cdelgado/extremes_outputs/'
  extra_variables_path = paste0(path_archives,'focus_outputs/D4.2/extra_variables/'),
  radiation_variables_path = paste0(path_archives,'boreas_outputs/radiation_variables/'),
  daily_variables_path = paste0(path_archives,'focus_outputs/D4.2/daily_variables/'),
  indices_path = path_indices,
  capacity_factors_models = paste0(path_archives,'capacity_outputs/outputs_capacity_models/'),
  seasons_solar = paste0(path_archives,'capacity_outputs/seasons_solar/'),
  capacity_factors_downscaled = paste0(path_archives,'capacity_outputs/outputs_capacity_downscaled/'),
  figures_path = paste0(path_archives,'capacity_outputs/figures_capacity/'),
  wind_path = paste0(path,'boreas_outputs/wind_variables/'),
  downscaling_path = paste0(path_archives,'capacity_outputs/downscaling_variables/'),
  ## Data
  variables = list('tas' = c('tas','tas_djf','tas_jja'), 
                   'pr' = c('pr','pr_djf','pr_jja'), 
                   'tas_indices' = c('tn10p','tx10p','tn90p','tx90p','txx','tnn','txx_djf','tnn_djf','tn10p_djf','tx90p_djf','txx_jja','tnn_jja','tn10p_jja','tx90p_jja'), 
                   'pr_indices' = c('r95ptot','r99ptot','rx1day','rx5day','prcptot','rx5day_djf','rx5day_jja'),
                   'rsds' = c('rsds'), 'sfcWind' = c('sfcWind'), 'psl' = c('psl')),
  
  observations = list('tas' = c('ERA5land'), 'pr' = c('ERA5land'), 'tas_indices' = c('ERA5land'), 'pr_indices' = c('ERA5land'), 'rsds' = c('ERA5land'), 'sfcWind' = c('ERA5land'), 'psl' = c('ERA5')), 

  models = c('BCC-CSM2-MR','CanESM5','CMCC-CM2-SR5','EC-Earth3-i1','EC-Earth3-i2','EC-Earth3-i4','HadGEM3-GC3.1-MM','IPSL-CM6A-LR','MIROC6','MPI-ESM1.2-HR','MRI-ESM2-0','NorCPM1-i1','NorCPM1-i2'),
  members = list('BCC-CSM2-MR'=8, 'CanESM5'=20, 'CMCC-CM2-SR5'=10, 'EC-Earth3-i1'=10, 'EC-Earth3-i2'=5, 'EC-Earth3-i4'=10, 'HadGEM3-GC3.1-MM'=10, 'IPSL-CM6A-LR'=10, 'MIROC6'=10, 'MPI-ESM1.2-HR'=10, 'MRI-ESM2-0'=10, 'NorCPM1-i1'=10, 'NorCPM1-i2'=10),
  predictors_names = c('AMV','NAO','SPOD','TPI'),
  
  multimodels = c('Multi-model-mean','Multi-model-pooled'),
  etccdi_indices = c('TX90p','TXx','TN10p','R95ptot'),
  ## Period
  years = 1961:2014,
  sdates = 1960:2013,
  reference_period = 1981:2010,
  fperiods = list(1, 1:5),
  ## Region
  regions = list('Iberia' = list('lon_min' = -10, 'lon_max' = 7, 'lat_min' = 35, 'lat_max' = 48),
                 'Atlantic' = list('lon_min' = -30, 'lon_max' = 30, 'lat_min' = 25, 'lat_max' = 70),
                 'Europe' = list('lon_min' = -12, 'lon_max' = 30, 'lat_min' = 36, 'lat_max' = 65),
                 'WestEuro' = list('lon_min' = -12, 'lon_max' = 10, 'lat_min' = 33, 'lat_max' = 63),
                 'Cat' = list('lon_min' = 0, 'lon_max' = 3, 'lat_min' = 40, 'lat_max' = 43),
                 'Gal' = list('lon_min' = -9.5, 'lon_max' = -6, 'lat_min' = 41, 'lat_max' = 44)), 
                 
  ## Computation
  interpolation_method = 'bil',
  ## Grid for downscalling
  grid_down = 'r3600x1801',
  grid_up = 'r128x64',
  grid_25 = 'r1441×721',
  n_categories = 3,
  alpha = 0.05,
  ncores = 5,
  max_jobs = 100,
  retrieve = FALSE,
  job_wallclock = '02:00:00',
  seasons = c('Annual','JFM','AMJ','JAS','OND')

)


## Creating the folders for the results (in case they don't exit yet)
if (!dir.exists(config$variables_path)){dir.create(config$variables_path, recursive = TRUE)}
if (!dir.exists(config$extra_variables_path)){dir.create(config$extra_variables_path, recursive = TRUE)}
if (!dir.exists(config$capacity_factors_models)){dir.create(config$capacity_factors_models, recursive = TRUE)}
if (!dir.exists(config$figures_path)){dir.create(config$figures_path, recursive = TRUE)}

