setwd('/esarchive/scratch/smoreno/gitlab/capacity_factors/')
source('config.R')

models <- config$models
region <- 'Iberia'
fyears_string <- 'fyear1'
values <- c('capacity_dcpp','capacity_obs','days_under_10_dcpp','days_under_10_obs','days_over_25_dcpp','days_over_25_obs')
config$seasons <- c('Annual','DJF','MAM','JJA','SON')
for (model in models){
  aux <- readRDS(file = paste0(config$seasons_solar,'seasons_solar_',model,'_',region,'_',fyears_string,'.rds'))
  acc_dcpp <- array(data = NA, dim = c(dim(aux$capacity_dcpp_DJF), value = 5))
  rmsss <- array(data = NA, dim = c(dim(aux$capacity_dcpp_DJF), value = 5))
  
  for (i in seq_along(config$seasons)){
    dcpp <- aux[[paste0('capacity_dcpp_',config$seasons[i])]]
    obs <- aux[[paste0('capacity_obs_',config$seasons[i])]]
    acc <- CorrEno(exp = dcpp, obs = obs, time_dim = 'year', member_dim = NULL, method = 'pearson', test.type = 'one-sided', alpha = config$alpha, pval = FALSE, ncores = config$ncores)
    acc_dcpp[,,i] <- acc
    rmsss <- RMSSS_edited(exp = dcpp, obs = obs, ref = NULL, ref_value = 0, test.type = 'greater', alpha = 0.05, time_dim = 'year', member_dim = NULL, ncores = config$ncores)
    rmsss_dcpp[,,i] <- rmsss 
  }
  
 
  
}