# setwd('/esarchive/scratch/smoreno/gitlab/capacity_factors/')
source('config.R')

args <- commandArgs(trailingOnly = TRUE)
# model <- 'BCC-CSM2-MR'
models <- config$models[13]
region <- 'Iberia'
fyear <- 'fyear1'
plot <- 'obs'

for (model in models){

data <- readRDS(file = paste0(config$seasons_solar,'solar_seasons_metrics_BCC-CSM2-MR_Iberia_fyear1.rds'))
data$capacity_dcpp_Annual <- MeanDims(data$capacity_dcpp_Annual, 'member')
data$capacity_dcpp_DJF <- MeanDims(data$capacity_dcpp_DJF, 'member')
data$capacity_dcpp_SON <- MeanDims(data$capacity_dcpp_SON, 'member')
data$capacity_dcpp_JJA <- MeanDims(data$capacity_dcpp_JJA, 'member')
data$capacity_dcpp_MAM <- MeanDims(data$capacity_dcpp_MAM, 'member')
# acc <- CorrEno(exp = data$capacity_dcpp_JJA, obs = data$capacity_obs_JJA
               # )
if (plot == 'obs'){
  values <- c('capacity_dcpp','capacity_obs','acc_dcpp','rmsss_dcpp')
  config$seasons <- c('Annual','DJF','MAM','JJA','SON')
  capacity_dcpp <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF), value = 5))
  capacity_obs <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF), value = 5))
  acc_dcpp <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF)[2:3], value = 5))
  acc_dcpp_sign <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF)[2:3], value = 5))
  rmsss_dcpp <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF)[2:3], value = 5))
} else {
  values <- c('capacity_dcpp','days_under_10_dcpp','days_over_25_dcpp')
  config$seasons <- c('Annual','DJF','MAM','JJA','SON')
  capacity_dcpp <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF), value = 5))
  days_under_10_dcpp <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF), value = 5))
  days_over_25_dcpp <- array(data = NA, dim = c(dim(data$capacity_dcpp_DJF), value = 5))
}


for (i in seq_along(config$seasons)){
  season <- config$seasons[i]
  capacity_dcpp[,,,i] <- data[[paste0('capacity_dcpp_', season)]]
  # acc_dcpp_r[,,i] <- data[[paste0('acc_', season)]]$r
  # acc_dcpp_sign[,,i] <- data[[paste0('acc_', season)]]$sign
  # rmsss_dcpp[,,i] <- data[[paste0('rmsss_dcpp_',config$seasons[i])]]
  if (plot == 'obs'){
    capacity_obs[,,,i] <- data[[paste0('capacity_obs_',config$seasons[i])]]
  }
}
capacity_dcpp <- MeanDims(data = capacity_dcpp, dims = 'sdate')
capacity_obs <- MeanDims(data = capacity_obs, dims = 'sdate')

acc_dcpp[,,1] <- data$acc_annual$r
acc_dcpp[,,2] <- data$acc_DJF$r
acc_dcpp[,,3] <- data$acc_MAM$r
acc_dcpp[,,4] <- data$acc_JJA$r
acc_dcpp[,,5] <- data$acc_SON$r
acc_dcpp_sign[,,1] <- data$acc_annual$sign
acc_dcpp_sign[,,2] <- data$acc_DJF$sign
acc_dcpp_sign[,,3] <- data$acc_MAM$sign
acc_dcpp_sign[,,4] <- data$acc_JJA$sign
acc_dcpp_sign[,,5] <- data$acc_SON$sign
special_args <- ClimProjDiags::ArrayToList(data = acc_dcpp_sign, dim = 'value', level = 'list', names = '')

acc_sign_list <- list(
  list(dots = !acc_dcpp_sign[,,1], dot_size = 0.7),  
  list(dots = NA),  
  list(dots = NA),  
  list(dots = NA),  
  list(dots = !acc_dcpp_sign[,,2], dot_size = 0.7),  
  list(dots = !acc_dcpp_sign[,,3], dot_size = 0.7),  
  list(dots = !acc_dcpp_sign[,,4], dot_size = 0.7),  
  list(dots = !acc_dcpp_sign[,,5], dot_size = 0.7)
)

acc_list <- ClimProjDiags::ArrayToList(data = acc_dcpp, dim = 'value', level = 'list', names = '')
acc_fin <- list()
acc_fin[1] <- acc_list[1]
acc_fin[2:4] <- NA
acc_fin[5:8] <- acc_list[2:5]
PlotLayout(
  fun = PlotEquiMap, 
  plot_dims = c('lon', 'lat'), 
  ncol = 4, 
  var = acc_fin, 
  special_args = acc_sign_list,
  # special_args = acc_sign_list,
  fileout = paste0(config$figures_path,'acc_seasons_',value,'_',model,'2.png'), 
  lon = data$lon, 
  lat = data$lat, 
  filled.continents = FALSE, 
  filled.oceans = 'gray',
  titles = c('Annual (7.59%)',' ',' ',' ','Winter (0%)','Spring (8.17%)','Summer (1.35%)','Autumn (0.8%)'),
  brks =  seq(-0.9,0.9,0.1),
  bar_extra_labels = seq(-0.9,0.9,0.1),
  width = 12,
  # cols = colors,
  triangle_ends = c(T,T)
)

dsdfd
for (value in values[1]) {
  var <- get(value)
  if (value == 'capacity_dcpp' | value == 'capacity_obs'){
    brks <- seq(0,30,1)
    colors <- colorRampPalette(c("white", "blue"))(21)
  } else if (value == 'acc_dcpp' | value == 'rmsss_dcpp') {
    brks <- seq(-0.9,0.9,0.1)
    # colors <- colorRampPalette(c("white", "blue"))(18)
  } 

  var_list <- ClimProjDiags::ArrayToList(data = capacity_dcpp, dim = 'value', level = 'list', names = '')
  var_fin <- list()
  var_fin[1] <- var_list[1]
  var_fin[2:5] <- NA
  var_fin[5:8] <- var_list[2:5]
  
  PlotLayout(
    fun = PlotEquiMap, 
    plot_dims = c('lon', 'lat'), 
    ncol = 4, 
    var = var_fin, 
    # special_args = acc_sign_list,
    fileout = paste0(config$figures_path,'capacity_factors_seasons_',value,'_',model,'2.png'), 
    lon = data$lon, 
    lat = data$lat, 
    filled.continents = FALSE, 
    filled.oceans = 'gray',
    titles = c('Annual',' ',' ',' ','Winter','Spring','Summer','Autumn'),
    brks = brks,
    bar_extra_labels = brks,
    units = '%',
    width = 12,
    triangle_ends = c(T,T)
  )
}
}