# setwd('/esarchive/scratch/smoreno/gitlab/capacity_factors/')
source('config.R')
args <- commandArgs(trailingOnly = TRUE)
model <- args[1]
models <- config$models
region <- 'Cat'
fperiods <- '1'
# config$ncores <- 1
# config$regions = list('WestEuro' = list('lon_min' = -8, 'lon_max' = -2, 'lat_min' = 31, 'lat_max' = 37))
model <- 'EC-Earth3-i1'
config$ncores <- 1

if (identical(fperiods,'all')){
  fperiods <- config$fperiods
} else {
  aux <- unlist(strsplit(x = fperiods, split = ','))
  fperiods <- list()
  for (i in 1:length(aux)){
    auxi <- unlist(strsplit(x = aux[i], split = '-'))
    fperiods[[i]] <- seq(from = auxi[1], to = auxi[length(auxi)], by = 1)
  }
}
fyears <- fperiods
fyears_string <- paste0('fyear',fyears)
capacity <- readRDS(file = paste0(config$capacity_factors_models,'solar_capacity_factor_',model,'_',fyears_string,'_',region,'.rds'))

capacity_obs <- capacity$pv_obs
capacity_dcpp <- capacity$pv_dcpp
lon <- capacity$lon
lat <- capacity$lat
dates <- capacity$dates
dates_mer <- as.PCICt(x = .POSIXct(xx = sapply(s2dv::Reorder(data = dates, order = c('time','sdate')),I), tz = attr(dates,'tzone')), cal = 'proleptic_gregorian')
capacity_dcpp <- CSTools::MergeDims(data = capacity_dcpp, merge_dims = c('time','sdate'), rename_dim = 'time', na.rm = FALSE)
capacity_dcpp_wm <- MeanDims(data = capacity_dcpp, dims = 'member')
capacity_dcpp_wm <- s2dv::Reorder(data = capacity_dcpp_wm, order = c('lon','lat','time'))
capacity_obs <- CSTools::MergeDims(data = capacity_obs, merge_dims = c('time','sdate'), rename_dim = 'time', na.rm = FALSE)
capacity_obs <- s2dv::Reorder(data = capacity_obs, order = c('lon','lat','time'))

percentil_90 <- apply(capacity_dcpp_wc, c(2, 3), function(x) quantile(x, 0.9, na.rm = TRUE))
percentil_10 <- apply(capacity_dcpp_wc, c(2, 3), function(x) quantile(x, 0.1, na.rm = TRUE))
mask_10 <- capacity_dcpp_wm < 10
days_under_10 <- apply(mask_10, c(1, 2), sum) 
mask_25 <- capacity_dcpp_wm > 25
days_over_25 <- apply(mask_25, c(1, 2), sum) 


PlotEquiMap(var = days_under_10, lon = lon, lat = lat, fileout = 'days_under_10_EC-Earth3-i1.png', #brks = seq(0,20,1), 
            width = 5, height = 6, triangle_ends = c(T,T), title_scale = 0.7,
            filled.oceans = TRUE, filled.continents = FALSE, toptitle = 'Amount of days under 10% EC-Earth3-i1')
PlotEquiMap(var = days_over_25, lon = lon, lat = lat, fileout = 'days_over_25_EC-Earth3-i1.png', #brks = seq(0,20,1), 
            width = 5, height = 6, triangle_ends = c(T,T), title_scale = 0.7,
            filled.oceans = TRUE, filled.continents = FALSE, toptitle = 'Amount of days over 25% EC-Earth3-i1')












